//
//
//
//    Arduino Mega
//    Ramps 1.4
//    Makerbase mks mini 12864 v2.0
//    Ramps1.4 adapter Pinboard panel connector module 
//    Nema 17 - 2 шт
//    A4988 - 2 шт
//    Концевик оптический
//    Блок питания на 12 В
//


// файл настроек
#include "defines.h"
// библиотека EEPROM
#include "EEPROM.h"

// библиотека дисплея
// https://github.com/olikraus/u8g2/wiki/setup_tutorial
#include <Arduino.h>
#include <U8g2lib.h>
#include <SPI.h>
// создание объекта дисплея MKS MINI 12864 v2.0
U8G2_ST7567_ENH_DG128064I_F_4W_HW_SPI u8g2(U8G2_R2, /* cs=*/ PIN_LCD_CS, /* dc=*/ PIN_LCD_A0, /* reset=*/ -1);

// библиотека энкодера
#include <RotaryEncoder.h>
// создание объекта энкодера
RotaryEncoder encoder(PIN_EN1, PIN_EN2);

// переменные
int pos_encoder;
int max_encoder;
int min_encoder;
int step_encoder;
unsigned long t1,t2;
unsigned long millisd;

const char *level0Names[12]={
  "Стоп",
  "Старт",
  "< Камера >",
  "Режим",
  "X ",
  "Y ",
  "V1  ",
  "L1 мм ",
  "V2  ",
  "L2 мм ",
  "Angle ",
  "Цикл ",
};
int arrpos0[]={1,2,3,6,7,8,9,10,11};
int countpos0=9;


int paramvalue[12]={0,  0,  5, 1, 1000, 1000, 100, 900,  5, 240,  50, 1};
int minvalue[12]=  {0,  0,  0, 1,    5,  100,  50, 100,  1,  20,   0, 0};
int maxvalue[12]=  {10,10, 10, 2, 2000, 5000, 400,2000, 50,1500, 180, 1};
int stepvalue[12]= {1,  1,  1, 1,   50,  100,   5,  20,  1,  20,   1, 1};
int kvalue[12] =   {1,  1,  1, 1,    1,    1,  10,   1, 10,   1,   1, 1};

struct MENU {
  int level;
  int pos0;
  int res_menu;    // 1,2,3
  int res_menu_pr; // 1,2,3
  int countpos0;
};

struct MOTOR {
  int run;   // 0, 1
  int start; // 0,1
  long x1t;
  //long x2t;
  long anglet;
  int dirx;
  int diry;
  int res;
  int anglestart;

  long x;
  long y;
  long l1;
  long l2;
  unsigned int v1;
  unsigned int v2;
  long angle;
  boolean circle;
  
  unsigned long microsmotor1;
  unsigned long microsmotor2;
  unsigned long micros1;
  unsigned long micros2;
};

MENU MENU1={0,0,1,1,9};
MOTOR MOTOR1={0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,1,
              0,0,0,0};

void setup() {
  // запуск последовательного порта
  Serial.begin(115200);
  // первичная установка параметров
  if(EEPROM.read(19)!=87) {
     set_default_params();
     EEPROM.write(19,87);
  }
  // загрузка параметров из EEPROM
  get_custom_params();
  // конфигурация контактов
  pinMode(PIN_ENC,INPUT_PULLUP);
  pinMode(PIN_BUTTON_STOP,INPUT_PULLUP);
  pinMode(PIN_BEEP,OUTPUT);
  // motor1
  pinMode(X_STEP_PIN,OUTPUT);
  pinMode(X_DIR_PIN,OUTPUT);
  pinMode(X_ENABLE_PIN,OUTPUT);
  digitalWrite(X_STEP_PIN,HIGH);
  digitalWrite(X_DIR_PIN,HIGH);
  digitalWrite(X_ENABLE_PIN,HIGH);
  // motor2
  pinMode(Y_STEP_PIN,OUTPUT);
  pinMode(Y_DIR_PIN,OUTPUT);
  pinMode(Y_ENABLE_PIN,OUTPUT);
  digitalWrite(Y_STEP_PIN,HIGH);
  digitalWrite(Y_DIR_PIN,HIGH);
  digitalWrite(Y_ENABLE_PIN,LOW);

  tone(PIN_BEEP,FREQ_BEEP4,1000);
  // начало работы с дисплеем
  u8g2.begin(); 
  // включаем поддержку UTF8
  u8g2.enableUTF8Print();
  // приветствие
  welcome();
  delay(3000);
  //
  if(paramvalue[3]==1) {
     MENU1.res_menu=1;
     MENU1.res_menu_pr=1;
     MENU1.countpos0=9;
  }
  else {
     MENU1.res_menu=2;
     MENU1.res_menu_pr=2;
     MENU1.countpos0=6;      
  }
  set_arrpos0(MENU1.res_menu);
  pos_encoder=0;
  max_encoder=MENU1.countpos0-1;
  min_encoder=0;
  step_encoder=1;
  set_menu(MENU1.level,MENU1.pos0,MENU1.pos0);
  //
  Serial.println("start");
} 

void loop() {
  // ************* проверка изменения энкодера *************
  encoder.tick();
  int new_pos_encoder = encoder.getPosition();
  if (pos_encoder != new_pos_encoder) {
    pos_encoder=new_pos_encoder;
    pos_encoder=min(pos_encoder,max_encoder);
    pos_encoder=max(pos_encoder,min_encoder);
    encoder.setPosition(pos_encoder);
    //Serial.print("enc=");Serial.println(pos_encoder);
    set_menu(MENU1.level,MENU1.pos0,pos_encoder*step_encoder);
  }
  // ************** проверка нажатия кнопок *************
  for(int i=0;i<countButtons;i++) {    
     currentButtons[i]=digitalRead(pinButtons[i]);
     if (lastButtons[i] != currentButtons[i]) {
        delay(5);
        if(currentButtons[i]==digitalRead(pinButtons[i])) {
          if (lastButtons[i] == 1 && currentButtons[i] == 0) {
             choice_menu(MENU1.level,i);
          }
        }
     lastButtons[i] = currentButtons[i];   
     }
  }
  // ****************   steppers  **************
  // *** идем в 0 слайдер
  if(MOTOR1.run==1 && MOTOR1.start==-1) {   
     go_to_start();  
     /*if(millis()-millisd>=1000) {
        if(arrpos0[MENU1.pos0]==0) {
           view_data0();
        }
        millisd=millis();
     }*/
  }
  // *** устанавливаем начальный угол режим2
  if(MOTOR1.run==1 && MOTOR1.start==-2) {   
     go_to_start_angle();  
     /*if(millis()-millisd>=1000) {
        if(arrpos0[MENU1.pos0]==0) {
           view_data();
        }
        millisd=millis();
     }*/
  }
  // *** выполняется программа движения
  else if(MOTOR1.run==1 && MOTOR1.start==1) {  
     // motor1 
     if(micros()-MOTOR1.micros1 >= MOTOR1.microsmotor1) {
        digitalWrite(X_STEP_PIN,HIGH);
        delayMicroseconds(10);
        digitalWrite(X_STEP_PIN,LOW);
        MOTOR1.x1t=MOTOR1.x1t+MOTOR1.dirx;
        //
        if(MOTOR1.res==2 && (MOTOR1.x1t%DX==0 
            || MOTOR1.x1t==MOTOR1.l1 || MOTOR1.x1t==0)) {
           res2_set_angle_param();
        }
        // изменение направления движения
        motor1_change_dir();  
        // 
        MOTOR1.micros1=micros();
     }
     // motor2
     if(micros()-MOTOR1.micros2 >= MOTOR1.microsmotor2 ) {
        // проверка начала движения второго мотора
        motor2_start();
        if(MOTOR1.anglestart==1) {
           digitalWrite(Y_STEP_PIN,HIGH);
           delayMicroseconds(10);
           digitalWrite(Y_STEP_PIN,LOW);
           MOTOR1.anglet=MOTOR1.anglet+MOTOR1.diry;
           // изменение направления движения мотора 2
           if(MOTOR1.res==1) {
              motor2_change_dir();
           }  
        }
        // 
        MOTOR1.micros2=micros();
     }
     /*if(millis()-millisd>=1000) {
        if(arrpos0[MENU1.pos0]==0) {
           view_data();
           //Serial.print("x1t=");Serial.println(MOTOR1.x1t);
           //Serial.print("anglet=");Serial.println(MOTOR1.anglet);
        }
        millisd=millis();
     }*/
  }
  // 

}
